#include "stdafx.h"

//char* ipAddress = "76.65.182.54";
char ipAddress[256];



int oldTest(int argc, char** argv)
{
	int offset = 0;
	MySqlTools myTool;

	if (argc == 1)
	{
		offset = 0;
	}
	if (argc == 2)
	{
		sscanf(argv[1], "%d", &offset);
	}
	if (argc>2)
	{
		printf("usage: mysqlTools [offset_number]\n");
		return 0;
	}
	
	myTool.init(ipAddress);	
	myTool.saveToFile(29087);
	return 0;
}

void savePictureFromDB(TCHAR*  idStr)
{
	int id = 0;
	MySqlTools myTool;
	if (_stscanf(idStr, _T("%d"), &id)!= 0)
	{
		if (myTool.init(ipAddress))
		{
			myTool.saveToFile(id);
		}
	}
}

void savePictureFromFile(TCHAR* fileName)
{
	LPBYTE ptr = NULL;
	MySqlTools myTool;	  
	DWORD  size = 0;
	if (myTool.init(ipAddress))
	{
		if (mapFile(fileName, ptr, size))
		{
			myTool.doSaveToFile(ptr, size);
		}
	}
}

void remakePicture(TCHAR*  idStr)
{
	int id = 0;
	MySqlTools myTool;	
	if (_stscanf(idStr, _T("%d"), &id)!= 0)
	{  
		if (myTool.init(ipAddress))
		{
			myTool.remakePicture(id);
		}
	}
}	 




void handleCommand(int argc, TCHAR** argv)
{
	MySqlTools myTool;
	int id, count;
	if (argc == 3)
	{ 
		if (_tcsicmp(argv[1], _T("remake"))==0)
		{  				
			remakePicture(argv[2]);
		}
		else
		{
			if (_tcsicmp(argv[1], _T("retrieve"))==0)
			{  				
				savePictureFromDB(argv[2]);
			}
			else
			{
				if (_tcsicmp(argv[1], _T("insert"))==0)
				{
					myTool.batchInsert(argv[2], ipAddress);
				}
			}
		} 		
	}
	else
	{
		if (argc == 4)
		{		
			if (_tcsicmp(argv[1], _T("replace"))==0)
			{
				_stscanf(argv[2], _T("%d"), &id); 
				if (replacePicture(id, argv[3], ipAddress))
				{
					_tprintf(_T("successfully replaced picture id [%d]\n"), id);
				}
				else
				{
					_tprintf(_T("replaced picture id [%d] failed\n"), id);
				}				
			}			
		}
		else
		{
			if (argc == 5)
			{
				if (_tcsicmp(argv[1], _T("replace"))==0)
				{
					_stscanf(argv[2], _T("%d"), &id);
					_stscanf(argv[3], _T("%d"), &count);
					
					if (replacePicture(id, count, argv[4], ipAddress))
					{
						_tprintf(_T("successfully replaced picture id [%d--%d]\n"), id, id+count-1);
					}
					else
					{
						_tprintf(_T("replaced picture id [%d--%d] failed\n"), id, id+count-1);
					} 						 				
				}
			}
			else
			{
				_tprintf(_T("usage: mysqltools.exe [option] [param]\n"));		
			}
		}
	}	  
}


int _tmain(int argc, TCHAR** argv)
{
	if (getIpAddress(ipAddress))
	{
		handleCommand(argc, argv);
	}
	return 0;
}